package gonin.renevier.philippe.exempletest;


import android.content.Context;
import android.test.ActivityInstrumentationTestCase2;
import android.util.Log;

import java.util.List;


import static org.mockito.Matchers.any;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

/**
 * Created by Philippe on 13/02/2015.
 */


// essayer avec un TestCase classic...

public class TestConversion2 extends ActivityInstrumentationTestCase2<TodoList> {

    Sauvegarde mockSauvegarde;
    Sauvegarde.Donnees [] loaded ;
    TodoList todo;


    /** données pour le mock **/
    String [] notes = { "txt = une dernière (1) || dateButtoir = 1424646313644 || dateCreation = 1423695934085" ,
            "txt = une dernière + 1 || dateButtoir = 1424646313644 || dateCreation = 1423695934085" ,
            "txt = toto || dateButtoir = 1423609723596 || dateCreation = 1423609729089" ,
            "txt = yuip || dateButtoir = 1425683388340 || dateCreation = 1423609796536" ,
            "txt = azerty || dateButtoir = 1424560229853 || dateCreation = 1423696242824"};

    Long [] buttoirs = {1424646313644L, 1424646313644L, 1423609723596L, 1425683388340L, 1424560229853L};
    Long [] creations = {1423695934085L, 1423695934085L, 1423609729089L, 1423609796536L, 1423696242824L};

    public TestConversion2(  ) {this(TodoList.class);}
    public TestConversion2(Class<TodoList> activityClass) {
        super(activityClass);
    }


    protected void setUp() throws Exception {
        super.setUp();

        System.setProperty(
                "dexmaker.dexcache",
                getInstrumentation().getTargetContext().getCacheDir().getPath());


        mockSauvegarde = mock(Sauvegarde.class);
        loaded = new Sauvegarde.Donnees[notes.length];
        for(int i = 0; i < notes.length; i++) {
            loaded[i] = mockSauvegarde.new Donnees(notes[i], buttoirs[i], creations[i]);
        }

        // doReturn(loaded).when(mockSauvegarde).charger(any(Context.class));
        when(mockSauvegarde.charger(any(Context.class))).thenReturn(loaded);
        TodoList.sauvegarde = mockSauvegarde;


        todo = getActivity();

    }


    public void testCreationItem() {


        List<Item> items = todo.getListItem();

        for(Item i : items) Log.d("Test_Static", "items : " + i.getNote());
        for( Sauvegarde.Donnees i : loaded) Log.d("Test_Static", "loaded : " + i.note);

        assertEquals("nb item attendu : "+notes.length, notes.length, items.size());
        for(int i = 0; i < notes.length; i++) {
            Item item = items.get(i);
            assertEquals("texte de "+i, notes[i], item.getNote());
            assertEquals("creation de "+i, (long) buttoirs[i], item.getButtoir());
            assertEquals("buttoir de "+i, (long) creations[i], item.getCreation());
        }


    }



    public void testLoadingTwoTimeItem() {

        Log.d("Test_Static", "***************** testLoadingTwoTimeItem *****************");
        Log.d("Test_Static", "***************** testLoadingTwoTimeItem *****************");
        Log.d("Test_Static", "***************** testLoadingTwoTimeItem *****************");

        todo.chargerNoteEnregistees();
        List<Item> items = todo.getListItem();

        for(Item i : items) Log.d("Test_Static", "items : " + i.getNote());
        for( Sauvegarde.Donnees i : loaded) Log.d("Test_Static", "loaded : " + i.note);

        assertEquals("nb item attendu : "+notes.length, notes.length, items.size());
        for(int i = 0; i < notes.length; i++) {
            Item item = items.get(i);
            assertEquals("texte de "+i, notes[i], item.getNote());
            assertEquals("creation de "+i, (long) buttoirs[i], item.getButtoir());
            assertEquals("buttoir de "+i, (long) creations[i], item.getCreation());
        }


    }
}
