package gonin.renevier.philippe.exempletest;

import android.app.Activity;
import android.app.Fragment;
import android.app.FragmentTransaction;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.TextView;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

public class Item extends Fragment implements OnClickListener, Datee {
	
		
	private View chargee;
	private ViewGroup parent;
	

	private long myNumb = -1;
	
	private Date buttoir ;
    SimpleDateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy", Locale.FRANCE);
    Calendar calendrier = Calendar.getInstance(Locale.FRANCE);
	private ListeItem listeItems;


    private String note = "";

    
    @Override
    public void onCreate(Bundle saved) {
    	super.onCreate(saved);

    	 if (saved == null) myNumb =  calendrier.getTime().getTime()   ;
         else 
         {
         	myNumb = saved.getLong("creation");

         	Activity a = getActivity();
         	if (a instanceof ListeItem) {
         		listeItems = (ListeItem)a ;
         		listeItems.addItem(this);
         	}

         }
         /**/
    }

	
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
        Bundle saved) {

        Log.d("saving", "onCreateView : myNumb = " + myNumb);
        // Inflate the layout for this fragment
    	this.parent = container;
    	
    	// les params
    	Bundle args = getArguments();
    	
    	note = args.getString("txt");
        this.chargee =  inflater.inflate(R.layout.item, container, false);


        // recuperation de la date de creation apres un chargement
        if (args.containsKey("dateCreation")) {
            myNumb = args.getLong("dateCreation");
        }
        
        chargee.setTag("item_"+myNumb);
        
        View noteView = chargee.findViewWithTag("note");
        if (noteView != null) ((TextView) noteView).setText(note);
        
        View actionView = chargee.findViewWithTag("action");
        actionView.setOnClickListener(this);
        
        // gestion de la date buttoir
        buttoir = (Date) args.getSerializable("dateButtoir");
        Date creation = new Date(myNumb);
        TextView dates = (TextView) chargee.findViewWithTag("dates");
        dates.setText("tâche créée le "+formatDate.format(creation)+" pour le "+formatDate.format(buttoir));
        
        // initialisation du bouton "up"
        ImageButton up = (ImageButton) chargee.findViewWithTag("up");
        up.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				changePosition(v, true, false);
				
			}
		});
        
        up.setOnLongClickListener(new OnLongClickListener() {
			@Override
			public boolean onLongClick(View v) {
				return changePosition(v, true, true);
			}
		});
        
        // initialisation du bouton "down"
        ImageButton down = (ImageButton) chargee.findViewWithTag("down");
        down.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				changePosition(v, false, false);
				
			}
		});
        
        down.setOnLongClickListener(new OnLongClickListener() {
			@Override
			public boolean onLongClick(View v) {
				return changePosition(v, false, true);
			}
		});
        
        return chargee;
    }
    
    
    
    private boolean changePosition(View v, boolean monter, boolean jusquaubout) {
    	int nbFrag = parent.getChildCount();
    	if (nbFrag > 1) {
			int index = parent.indexOfChild(chargee);
			if ( monter && (index > 0)) {
				// l'ordre se pert en cas de rotation...
				parent.removeView(chargee);
				if (jusquaubout) parent.addView(chargee, 0);
				else parent.addView(chargee, index-1);
			}
			else if ( (! monter) && (index < (nbFrag-1)) ) {
				parent.removeView(chargee);
				if (jusquaubout) parent.addView(chargee, nbFrag-1);
				else parent.addView(chargee, index+1);
			}
		}
		return false;
    }
	
    

    // public int indexOfChild (View child) 
    // http://developer.android.com/reference/android/view/ViewGroup.html#indexOfChild%28android.view.View%29
    
	@Override
	public void onClick(View v) {
		listeItems.removeItem(this);
		FragmentTransaction fragmentTransaction = getFragmentManager().beginTransaction();
		fragmentTransaction.remove(this);
		fragmentTransaction.commit();
	}
	
	
	public static Item newInstance(String txt, Date dateButtoir) {
		Item fragment = new Item();
	    Bundle args = new Bundle();
	    
	    args.putString("txt", txt);
	    args.putSerializable("dateButtoir", dateButtoir);

	    fragment.setArguments(args);
	    return fragment;
	}



    public static Item load(String txt, long dateButtoir, long dateCreation) {
        Log.d("saving", "charger (Item) : txt = "+txt+" || dateButtoir = "+dateButtoir + " || dateCreation = "+dateCreation);

        Item fragment = new Item();
        Bundle args = new Bundle();

        args.putString("txt", txt);
        args.putSerializable("dateButtoir", new Date(dateButtoir));
        args.putLong("dateCreation", dateCreation);

        fragment.setArguments(args);
        return fragment;
    }
	
	/**
	 * partie pour sauvegarder les données
	 * nécessaire quand on gère la date dans la création de la vue... 
	 */
	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		
		outState.putLong("creation", myNumb);
	}


	@Override
	public long getCreation() {
		return myNumb;
	}


	@Override
	public long getButtoir() {
		/* if (buttoir == null) return -1;
        else */
        return buttoir.getTime();
	}


    public String getNote() { return this.note; }




	public void setListeItem(ListeItem listeItems) {
		this.listeItems = listeItems;
	}



    // method equals surchare dans Fragment...
    public boolean testEquals(String note, long buttoir, long creation){
        boolean res = false ;

        if (note != null) {
            res = this.note.equals(note) && (this.myNumb == creation) && (this.getButtoir() == buttoir);
        }

        return res;
    }
	

}
