package gonin.renevier.philippe.exempletest;

import android.content.Context;
import android.util.Log;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by Philippe on 12/02/2015.
 */
public class Sauvegarde {

    final String SEPARATOR = "#;#";
    final String FILENAME = "save.txt";


    private static Sauvegarde currentInstance = null;

    public static Sauvegarde getInstance() {
        if (currentInstance == null) currentInstance  = new Sauvegarde();
        return currentInstance;
    }



    private Sauvegarde() {
    }


    public class Donnees {
        public Donnees(String n, long b, long c) {
            note = n;
            dateButtoir = b;
            dateCreation = c;
        }

        public String note = "";
        public long dateButtoir = 0;
        public long dateCreation = 0;

    }

    public Donnees[] charger(Context c) {
        ArrayList<Donnees> loaded = new ArrayList<Donnees>();

        FileInputStream fos = null;
        try {
            fos = c.openFileInput(FILENAME);
            InputStreamReader isr = new InputStreamReader(fos);
            BufferedReader buffreader = new BufferedReader(isr);

            String readString = buffreader.readLine();
            while (readString != null) {
                if (!readString.equals("")) {
                    String[] split = readString.split(SEPARATOR);
                    if (split.length == 3) {
                        String note = split[0];
                        long dateButtoire = Long.parseLong(split[1]);
                        long dateCreation = Long.parseLong(split[2]);

                        loaded.add(new Donnees(note, dateButtoire, dateCreation));
                    }
                }

                readString = buffreader.readLine();
            }

            isr.close();


        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        Donnees[] result = new Donnees[loaded.size()];
        return loaded.toArray(result);
    }


    public void sauvegarder(List<Item> mesItems, Context c) {
        FileOutputStream fos = null;
        try {
            fos = c.openFileOutput(FILENAME, Context.MODE_PRIVATE);
            OutputStreamWriter osw = new OutputStreamWriter( fos ) ;

            String save = "/* saved to do list */\n";

            for(Item i : mesItems) {
                save += ""+i.getNote()+SEPARATOR+i.getButtoir()+SEPARATOR+i.getCreation()+"\n";
            }

            Log.d("Mock", "write ");
            osw.write ( save ) ;
            osw.close ( ) ;

        } catch (FileNotFoundException e) {

            e.printStackTrace();
        } catch (IOException e) {

            e.printStackTrace();
        }
    }



}
