package gonin.renevier.philippe.exempletest;

import android.app.Activity;
import android.app.FragmentManager;
import android.app.FragmentTransaction;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collections;
import java.util.Locale;


// passage de Activity à FragmentActivity pour avoir la liste des Fragments...
public class TodoList extends Activity implements ChoisirDateButtoir.EcouterChangementDate,ListeItem {
    static int indice = 0;

    LinearLayout liste;
    EditText nouveau;
    Button ajouter;
    TextView date;

    RelativeLayout topcontainer;

    FragmentManager fragmentManager = getFragmentManager();

    // format pour la date...
    SimpleDateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy", Locale.FRANCE);
    Calendar calendrier ;


    final String FILENAME = "save.txt";
    final String SEPARATOR = "#;#";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.list_ui);

        // recuperation
        nouveau = (EditText) findViewById(R.id.nouveau);
        ajouter = (Button) findViewById(R.id.ajouter);
        liste = (LinearLayout) findViewById(R.id.liste);
        topcontainer = (RelativeLayout) findViewById(R.id.topcontainer);

        // init de la date
        date = (TextView) findViewById(R.id.date);
        calendrier = Calendar.getInstance(Locale.FRANCE);
        date.setText(formatDate.format(calendrier.getTime()));

        // event sur le bouton
        ajouter.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // click sur le bouton;
                String nouvMsg = nouveau.getText().toString();

                FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                Item newFragment = Item.newInstance(nouvMsg, calendrier.getTime());
                addItem(newFragment);
                newFragment.setListeItem(TodoList.this);
                fragmentTransaction.add(R.id.liste, newFragment);
                fragmentTransaction.commit();

                nouveau.setText("");

            }
        });



        /** loading **/
        /** but not in a rotation... or a restore... **/
        if (savedInstanceState == null) {


            /*** code initial, non testable separement... ***/
            /*
            FileInputStream fos = null;
            try {
                fos = openFileInput(FILENAME);
                InputStreamReader isr = new InputStreamReader(fos);
                BufferedReader buffreader = new BufferedReader(isr);

                String readString = buffreader.readLine();
                while (readString != null) {
                    if (!readString.equals("")) {
                        String[] split = readString.split(SEPARATOR);
                        if (split.length == 3) {
                            String note = split[0];
                            long dateButtoire = Long.parseLong(split[1]);
                            long dateCreation = Long.parseLong(split[2]);


                            FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();

                            Item newFragment = Item.charger(note, dateButtoire, dateCreation);
                            addItem(newFragment);
                            newFragment.setListeItem(this);
                            fragmentTransaction.add(R.id.liste, newFragment);

                            fragmentTransaction.commit();

                        }
                    }

                    readString = buffreader.readLine();
                }

                isr.close();


            } catch (FileNotFoundException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            */

            chargerNoteEnregistees();
        }
    }


    public void chargerNoteEnregistees() {
        Sauvegarde io = requestSauvegardeManager();
        Sauvegarde.Donnees[] loaded = io.charger(this);

        for(Sauvegarde.Donnees d : loaded) {
            Log.d("Test_Static", "chargerNoteEnregistees sauvegarde "+d.note+" taille de la liste : "+mesItems.size());


            Item newFragment = Item.load(d.note, d.dateButtoir, d.dateCreation);
            Log.d("Test_Static", "chargerNoteEnregistees call add with "+newFragment);
            if (! testeDejaCharge(d)) {
                Log.d("Test_Static", "***************** adding a new fragment *****************");
                addItem(newFragment);
                FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                newFragment.setListeItem(this);
                fragmentTransaction.add(R.id.liste, newFragment);
                fragmentTransaction.commit();
            }

        }
    }




    /**
     * specific for test...
     * @return
     */
    protected  static Sauvegarde sauvegarde = Sauvegarde.getInstance();
    protected Sauvegarde requestSauvegardeManager() {
        Log.d("Test_Static", "calling sauvegarde "+sauvegarde);
        return sauvegarde ;
    }


    public void sauvegarderNotes() {
        Sauvegarde io = requestSauvegardeManager();
        io.sauvegarder(mesItems, this);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.list, menu);
        return true;
    }


    // pour alterner les tris
    ComparerDate dernierTri = null;
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.tri_buttoir:
                if ((dernierTri != null) && (dernierTri.equals(ComparerDate.BUTTOIR_CROISSANT))) dernierTri = ComparerDate.BUTTOIR_DECROISSANT;
                else dernierTri = ComparerDate.BUTTOIR_CROISSANT;
                trier(dernierTri);
                break;
            case R.id.tri_creation:
                if ((dernierTri != null) && (dernierTri.equals(ComparerDate.CREATION_CROISSANT))) dernierTri = ComparerDate.CREATION_DECROISSANT;
                else dernierTri = ComparerDate.CREATION_CROISSANT;
                trier(dernierTri);
                break;
            case R.id.sauvegarde:
                sauvegarderNotes();
                break;
            default:
                return super.onOptionsItemSelected(item);
        }


        return true;
    }


    @Override
    public void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);

        // sauvegarde de la place des fragments
        Bundle ordre = new Bundle();

        int nbFrag = liste.getChildCount();
        for(int i = 0; i < nbFrag; i++) {
            View v = liste.getChildAt(i);
            Log.println(Log.DEBUG, "pour info", "" + v.getTag());
            ordre.putInt(v.getTag().toString(), i);
        }

        outState.putBundle("ordre", ordre);

        // sauvegarde de la date
        outState.putString("date", date.getText().toString());

    }

    @Override
    public void onRestoreInstanceState(Bundle inState) {
        super.onRestoreInstanceState(inState);

        // on restaure l'ordre des fragments
        Bundle ordre = inState.getBundle("ordre");

        int nbFrag = liste.getChildCount();
        View [] ordreView = new View[nbFrag];

        for(int i = nbFrag-1; i >= 0; i--) {
            View v = liste.getChildAt(i);
            int place = ordre.getInt(v.getTag().toString());
            ordreView[place] = v;
            liste.removeView(v);
        }

        for(View v : ordreView) if (v != null) liste.addView(v);

        // on restaure la date
        date.setText(inState.getString("date"));

    }


    /**
     * methode pour le bouton de changement de date
     */
    public void demanderDate(View v) {
        Toast t = Toast.makeText(getApplicationContext(), "demande de la date", Toast.LENGTH_SHORT);
        t.show();
        // lancement du fragment comme boite de dialogue.

        ChoisirDateButtoir fragChoixDate = new ChoisirDateButtoir();
        fragChoixDate.setEcouterChangementDate(this);

        fragChoixDate.show(fragmentManager, "Choisissez la date buttoir");

    }


    @Override
    public void setDate(int year, int month, int day) {
        if (calendrier == null) calendrier = Calendar.getInstance(Locale.FRANCE);
        calendrier.set(year, month, day);
        date.setText(formatDate.format(calendrier.getTime()));

    }



    /**
     * pour gérer la liste des fragments
     * pas de méthode simple
     * et ce qui est dans v4... ce sont d'autres classes...
     */

    // seule cette méthode existe, et pas pour detach... du coup
    // il faut passer par un système de communication
	/* @Override
	public void onAttachFragment(Fragment fragment) {

	}
	*/
    java.util.LinkedList<Item> mesItems = new java.util.LinkedList<Item>();

    public  java.util.List<Item> getListItem() {
        return mesItems;
    }



    private boolean testeDejaCharge(Sauvegarde.Donnees d) {
        boolean res = false;
        for (Item item : mesItems) {
            res = res || item.testEquals(d.note, d.dateButtoir, d.dateCreation) ;
            if (res) break;
        }

        return res;
    }

    @Override
    public void addItem(Item i) {
        Log.d("Test_Static", "addItem add "+i);

        if (mesItems == null) return ;

        if (! mesItems.contains(i))  mesItems.add(i);







    }


    @Override
    public void removeItem(Item i) {
        if (mesItems.contains(i)) mesItems.remove(i);

    }



    public void trier(ComparerDate tri) {
        Collections.sort(mesItems, tri);
        liste.removeAllViews();
        for(Item i : mesItems) liste.addView(i.getView());
    }



}
